"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AlarmLight = exports.okColor = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames2 = _interopRequireDefault(require("classnames"));

var _styles = require("@material-ui/core/styles");

var _FlexIcon = require("./FlexIcon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var okColor = '#00dd80';
exports.okColor = okColor;

var styles = function styles() {
  return {
    '@keyframes shake': {
      '0%': {
        transform: 'rotate(-5deg)'
      },
      '50%': {
        transform: 'rotate(3deg)'
      }
    },
    alarm: {
      animation: 'shake .2s linear infinite'
    }
  };
};

var propTypes = {
  classes: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  signal: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].number]),
  size: _propTypes["default"].number,
  animatedErr: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  okIconId: _propTypes["default"].string,
  errIconId: _propTypes["default"].string,
  iconStyle: _propTypes["default"].objectOf(_propTypes["default"].any)
};
var defaultProps = {
  signal: 1,
  iconStyle: {},
  animatedErr: true,
  size: 56,
  errIconId: 'warning',
  okIconId: 'check',
  className: ''
};
var hoc = (0, _styles.withStyles)(styles);

var AlarmLightC = function AlarmLightC(_ref) {
  var _classnames;

  var classes = _ref.classes,
      signal = _ref.signal,
      iconStyle = _ref.iconStyle,
      animatedErr = _ref.animatedErr,
      size = _ref.size,
      okIconId = _ref.okIconId,
      errIconId = _ref.errIconId,
      className = _ref.className;
  return !signal ? _react["default"].createElement(_FlexIcon.FlexIcon, {
    className: (0, _classnames2["default"])((_classnames = {}, _defineProperty(_classnames, classes.alarm, animatedErr), _defineProperty(_classnames, className, true), _classnames)),
    color: "error",
    style: _objectSpread({
      fontSize: size
    }, iconStyle)
  }, errIconId) : _react["default"].createElement(_FlexIcon.FlexIcon, {
    color: okColor,
    className: className,
    style: _objectSpread({
      fontSize: size
    }, iconStyle)
  }, okIconId);
};

AlarmLightC.propTypes = propTypes;
AlarmLightC.defaultProps = defaultProps;
var AlarmLight = hoc(AlarmLightC);
exports.AlarmLight = AlarmLight;